]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- set all flags in %cmake, like in %configure
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
f51bfb2f
ER
2# PLD Linux rpm macros.
3# <http://www.pld-linux.org/>
d54662bf 4
2b05614d 5# can be used by builder script to check for version
98c5c988
ER
6%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
7
e05017c1 8%epoch 0
3241033b 9%x8664 x86_64 amd64 ia32e
e483e029 10%arm armv3l armv4b armv4l armv5teb armv5tel
9c404149 11
ba1fdedc 12# kernel compiler
345d14e5 13%kgcc %{__cc}
d2e1bc22 14%kgcc_package gcc
ba1fdedc 15
46763914 16# compiler version
69bcfbf3 17%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 18%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 19
69bcfbf3 20%__rm /bin/rm --interactive=never
36eccf0d 21
33040789 22# Build system path macros.
69bcfbf3
ER
23%__autoconf autoconf %{?debug:-Wall}
24%__automake automake -a -c -f --foreign
25%__autopoint autopoint --force
26
27# add parallel build flags: -jN
a5656a95 28#
11ecb0a1
ER
29# if you want to disable parallel build do:
30# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
a5656a95 31#
11ecb0a1
ER
32%__make /usr/bin/make %{?_smp_mflags}
33%__scons /usr/bin/scons %{?_smp_mflags}
34%__waf /usr/bin/waf %{?_smp_mflags}
b8f83d42 35%__cmake /usr/bin/cmake
a5656a95
JR
36
37%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
38 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
f93109a0 39
83094b62 40%__gettextize { \
8a995cff 41 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 42 gettextize --copy --force --no-changelog; \
97589b6e 43 else \
3241033b 44 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
45 fi; \
46 if [ ! -f po/Makevars ]; then \
3241033b 47 cp -f po/Makevars{.template,}; \
8a995cff 48 fi; \
8a995cff 49}
f93109a0 50
51%__glib_gettextize glib-gettextize --copy --force
52%__gnome_doc_common gnome-doc-common --copy
fb59e475 53%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 54%__gtkdocize gtkdocize --copy
55%__intltoolize intltoolize --copy --force
c26f1b59 56%__libtoolize libtoolize --copy --force --install
33040789 57
751c2bdd
ER
58# topdir is where builder script lives,
59# fallback to old style if SPECS/SOURCES dirs were found.
60%_topdir %{expand:%%global _topdir %(
61 if [ -d SPECS -a -d SOURCES ]; then
62 # old style rpmdir: in topdir
df3151c2 63 pwd
751c2bdd
ER
64 elif [ -d ../SPECS -a -d ../SOURCES ]; then
65 # old style rpmdir: in subdir
df3151c2 66 cd ..; pwd
751c2bdd
ER
67 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
68 # if old style rpm dir exist, go with it
69 echo $HOME/rpm; \
70 elif [ -x ../builder -a ! -d ../builder ]; then
71 # relative new style rpmdir: in package dir
df3151c2 72 cd ..; pwd
751c2bdd
ER
73 elif [ -x builder -a ! -d builder ]; then
74 # relative new style rpmdir: in packages
df3151c2 75 pwd
751c2bdd
ER
76 elif [ -x packages/builder -a ! -d packages/builder ]; then
77 # relative new style rpmdir: packages dir in current dir
df3151c2 78 cd packages; pwd
751c2bdd
ER
79 else
80 # fallback to new style rpmdir
81 echo $HOME/rpm/packages
82 fi; \
83)}%_topdir
1052b4b8 84
751c2bdd
ER
85# if %{_topdir}/SPECS exists, it's old style structure
86%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
87%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
1052b4b8
ER
88
89# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
90# if they don't exist assume we are having custom topdir (which is not named as
91# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
df3151c2
ER
92# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
93%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
94%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
95%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
384e1b2b 96
81e450f7
ER
97# The number of cvs changelog entries kept when building package.
98%_buildchangelogtruncate 20
99
6a5eda77 100%dependencytracking %{nil}
3241033b 101
e5da9169
ER
102# Relations between package names that cause dependency loops
103# with legacy packages that cannot be fixed. Relations are
104# specified as
105# p>q
106# where package p has a Requires: on something that package q Provides:
107#
108# XXX Note: that there cannot be any whitespace within the string "p>q",
109# and that both p and q are package names (i.e. no version/release).
110%_dependency_whiteout %{nil}
111
810fa5c4 112#-----------------------------------------------------------------
113#
114# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
115# BuildRequires: awk
116# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 117#
118# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 119# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
120# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 121# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 122# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 123#
124# Regular expressions are supported, but to avoid some character be treated
125# as regular expression it must be escaped twice.
126
127%filter_out \
7b6f1112 128 for (i = 1; i in I; i++) { A=0; \
810fa5c4 129 for (f in F) { \
130 if (I[i] ~ "^" F[f] "$") A=1; \
131 }; \
132 if (!A) printf(I[i] FS); \
133 }
134
135%rpmcflags %(awk 'BEGIN {
136 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 137 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 138 %{filter_out}
139}')
140
141%rpmcxxflags %(awk 'BEGIN {
09a90176 142 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
143 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 144 %{filter_out}
145}')
146
98e7f050
AM
147%rpmcppflags %(awk 'BEGIN {
148 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
149 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
150 %{filter_out}
151}')
152
810fa5c4 153%rpmldflags %(awk 'BEGIN {
c05a0741 154 split("%{?optldflags}",I);
810fa5c4 155 split("%{?filterout_ld}",F)
156 %{filter_out}
157}')
158
25f52d1a 159# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
160# but, don't use it, better use gcc as linker
161%ld_rpmldflags %(awk 'BEGIN {
162 split("%{rpmldflags}",F);
163 for (f in F) {
164 s = F[f];
165 if (s ~ /^-Wl,/) {
166 s = substr(s,5);
167 gsub(/,/," ",s);
168 };
169 printf(s FS);
170 };
171}')
172
8ef644e5 173#-----------------------------------------------------------------
174#
175# Generate a command which cleans environment, leaving only the
176# most important variables.
177# If any spec requires any additional environment it should
178# redefine %_preserve_env in following manner:
179#
180# # ADDITIONAL_VAR is required because [a good reason here]
82d10503 181# %define _preserve_env ADDITIONAL_VAR
8ef644e5 182
57ba0f59 183%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
8ef644e5 184
bb597f2b
AM
185# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
186%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
0bdc88ec 187 split("%{?_preserve_env}", P);
a363d727
ER
188 for (i in P) {
189 p = P[i];
82d10503
ER
190 if (!ENVIRON[p] || d[p]) {
191 continue;
8ef644e5 192 }
82d10503
ER
193 d[p] = 1;
194 split(ENVIRON[p], V, "");
195 val = p "=";
196 for (j = 1; j in V; j++) {
197 v = V[j];
198 if (v == q)
199 v = qq;
200 else if (v == "\\"")
201 v = q2q;
202 else if (v == "\\\\")
203 v = "\\\\\\\\";
204 else
205 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
206 val = val "" v;
207 }
208 printf(val " ");
8ef644e5 209 }
210}')
211
9c404149 212#-----------------------------------------------------------------
9f4ce098 213%configure2_13 { \
9c404149
AM
214 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
215 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
216 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 217 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 218 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 219 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 220 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
221 %{?__cc:CC="%{__cc}" ; export CC ; } \
222 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 223 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 224 --host=%{_target_platform} \
9c404149
AM
225 --prefix=%{_prefix} \
226 --exec-prefix=%{_exec_prefix} \
227 --bindir=%{_bindir} \
228 --sbindir=%{_sbindir} \
229 --sysconfdir=%{_sysconfdir} \
230 --datadir=%{_datadir} \
231 --includedir=%{_includedir} \
232 --libdir=%{_libdir} \
233 --libexecdir=%{_libexecdir} \
234 --localstatedir=%{_localstatedir} \
235 --sharedstatedir=%{_sharedstatedir} \
236 --mandir=%{_mandir} \
237 --infodir=%{_infodir} \
b6c5da52 238 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 239 %{dependencytracking} \
9c404149
AM
240}
241
c4a85bd8 242%cmake \
d41caea6
ER
243%{?__cc:CC="%{__cc}"} \\\
244%{?__cxx:CXX="%{__cxx}"} \\\
245CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
246CFLAGS="${CFLAGS:-%{rpmcflags}}" \\\
247FFLAGS="${FFLAGS:-%{rpmcflags}}" \\\
248FCFLAGS="${FCFLAGS:-%{rpmcflags}}" \\\
249CXXFLAGS="${CXXFLAGS:-%{rpmcxxflags}}" \\\
250LDFLAGS="${LDFLAGS:-%{rpmldflags}}" \\\
c4a85bd8
ER
251%{__cmake} \\\
252 -DCMAKE_INSTALL_PREFIX=%{_prefix} \\\
253 -DCMAKE_BUILD_TYPE=%{!?debug:Release}%{?debug:Debug} \\\
c27b3ff8 254%if "%{_lib}" == "lib64" \
c4a85bd8 255 -DLIB_SUFFIX=64 \\\
9d1e0c01 256%endif \
c4a85bd8 257%{nil}
89f4ca1f 258
89f4ca1f
ER
259%scons { \
260%{__scons} \
5c76736d
ER
261 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
262 CFLAGS="${CFLAGS:-%rpmcflags}" \
263 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
264 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 265 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
266 %{?__cc:CC="%{__cc}"} \
267 %{?__cxx:CXX="%{__cxx}"} \
268 libsuffix=%{_lib} \
269 prefix=%{_prefix} \
39b9534b
ER
270}
271
6339d32d 272# waf. see waf.spec
6339d32d 273%waf { \
6339d32d
ER
274CC="%{__cc}" \
275CXX="%{__cxx}" \
9e244007 276CPP="%{__cpp}" \
6339d32d
ER
277CFLAGS="%{rpmcflags}" \
278CXXFLAGS="%{rpmcxxflags}" \
279%{__waf} \
6339d32d
ER
280}
281
4a6b0d54 282#----------------------------------------------------------------
9bacbb5b 283#%configure_cache 0
fe6c4bdd 284%configure_cache_file %{buildroot}.configure.cache
73f832b3 285
e84cd836 286%configure {./configure \
4a6b0d54
AF
287 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
288 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 289 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 290 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 291 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 292 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
293 %{?__cc:CC="%{__cc}"} \
294 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 295 --host=%{_target_platform} \
4a6b0d54
AF
296 --build=%{_target_platform} \
297 --prefix=%{_prefix} \
298 --exec-prefix=%{_exec_prefix} \
299 --bindir=%{_bindir} \
300 --sbindir=%{_sbindir} \
301 --sysconfdir=%{_sysconfdir} \
302 --datadir=%{_datadir} \
303 --includedir=%{_includedir} \
304 --libdir=%{_libdir} \
305 --libexecdir=%{_libexecdir} \
306 --localstatedir=%{_localstatedir} \
307 --sharedstatedir=%{_sharedstatedir} \
308 --mandir=%{_mandir} \
309 --infodir=%{_infodir} \
b6c5da52 310 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 311 %{dependencytracking} \
9bacbb5b 312 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
313}
314
611a25d5 315# Simple macros to simplify adding bconded options to configure scripts.
316# Each macro requires bcond name and accepts optional option name, if option
317# isn't specified bcond name is used as option name. Options returning
318# --with and --enable also allow third argument which will be added as value
319# ( --with-option=value or --enable-option=value ) in case or positive
320# condition, but won't be added otherwise ( nothing or just --disable-option ).
321
322# Requirements:
323# BuildRequires: rpmbuild(macros) >= 1.527
324
325# Usage example:
326# %{__enable bcond} - returns --enable-bcond iff build condition is set
327# %{__disable bcond option} - returns --enable-option iff bcond is not set
328# %{__enable_disable bcond option value} - returns --enable-option=value if
329# bcond is set, returns --disable-option otherwise
330
331# expand bconds to --enable-something and --disable-something
332%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
333%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
334%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
335
336# same as above, but condition inverted
337%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
338%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
339%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
340
341# expand bconds to --with-something and --without-something
342%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
343%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
344%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
345
346# same as above, but condition inverted
347%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
348%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
349%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
350
351#-----------------------------------------------------------------
352
b3b1397b
ER
353# overload to insert debuginfo package
354%prep \
355%if 0%{?_enable_debug_packages}\
356%{debug_package}\
357%endif\
358%%prep\
359%{nil}
360
9c404149 361# Location of autoconf macros
ef7d5e14 362%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
9c404149 363
e2804f99 364# Location of omf files
7f0f4a79 365%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 366
e987a186 367# Location of pkgconfig files
9a4e877a 368%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
369# noarch pkgconfig files
370%_npkgconfigdir /usr/share/pkgconfig
e987a186 371
486b0b5f 372# Location of desktop files
373%_desktopdir /usr/share/applications
86dff2d0 374%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 375
481463e9 376# Location of pixmaps for applnk/desktop files
e1f0a822 377%_pixmapsdir /usr/share/pixmaps
9c404149 378
481463e9 379# Location of themable icons for applnk/desktop files
b36c8e2a 380%_iconsdir /usr/share/icons
381
e987a186
JB
382# Location of fonts directories
383%_fontsdir /usr/share/fonts
384
b3282f3f 385# Location of Gtk and associated libraries documentation
fe6c4bdd 386%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 387
fc4d7771 388# Location of KDE documentation
fe6c4bdd 389%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 390
5869828c 391# unsermake script
392%__unsermake /usr/share/unsermake/unsermake
393
9c404149 394# Current date
8cf161e2 395%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 396
9c404149
AM
397# Example files, programs, scripts...
398%_examplesdir /usr/src/examples
399
c8f7e820 400# Alternative kernel type/version
261729d9 401%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 402
8377d27d 403# The directory holding Linux kernel sources
261729d9 404%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 405
c0fe61f0
ER
406# SysV-style initscripts dir
407%_initddir /etc/rc.d/init.d
408
9c404149 409# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 410%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 411
590bc1db 412# Bootstrap release macros.
413# Usage:
414# %bcond_with bootstrap
415# Release: %{bootstrap_release 1}
416#
417# Package will have release 1 if built normally,
418# and release 0.zzz.bootstrap if built with bootstrap
419%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
420
c924d9d8
ER
421# -n drm to generate kernel%{_alt_kernel}-drm dependency
422%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
423%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
424%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
8bf3719d 425
c924d9d8 426# -s post to generate Requires(post) dependency
63d9963a
ER
427%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
428%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
429%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 430
410df6e8
ER
431# Requires name = version-release
432%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 433# Requires: name = version
91d2f1eb 434%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 435# Requires: name = version (version based on querying package %2)
0d3e64c0 436%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 437
90c674d3
JR
438# Requires: name >= version
439%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
440# Requires: name >= version (version based on querying package %2)
441%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
442
c94807f3 443%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 444
445# kernel version-release handling
95125403 446%__kernel_ver %{expand:%%global __kernel_ver %( \\
acac3049 447 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
95125403
ER
448 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
449 echo ${Z:-ERROR}; \\
1a7d3518 450)}%__kernel_ver
95125403 451
c94807f3
ER
452%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
453%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
454%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
455%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 456
6262f001
ER
457# `uname -r` to be used in @release field
458%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
459
e00dd7f6 460# sgml macros
3241033b
ER
461%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
462%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
463%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
464%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
465%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
466%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 467%docbook_sgmlcat_fix() { for l in \
468'' \
469' -- default decl --' \
470'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
471' -- hacks for opensp --' \
472'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
473'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
474'' \
475; do echo $l; done >> %1 \
476}
477
eea64748
ER
478# vim - "
479
4f044018
ER
480# minimum file size needed for compressed documents.
481# just smaller files than this get larger when compressed.
a88ae20f
ER
482# some stats:
483# - 0 byte file compressed was 25 bytes .gz
484# - 39 byte file was compressed as 57
485# - with test/test.spec@man 158 byte file was compressed also 158
486%_min_compress_bytes 159
4f044018 487
9c404149
AM
488#-----------------------------------------------------------------
489# find and gzip all files in %{_mandir} and %{infodir}
490#
491# Requires: xargs, find
492#
493#%no_install_post_compress_docs 1
494%__spec_install_post_compress_docs { \
53d5af13 495%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 496 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 497 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 498 echo "Compress man pages: $i"; \
4f044018
ER
499 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
500 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
501 find $RPM_BUILD_ROOT$i -type l | while read a; do \
502 m=$(readlink $a); \
503 rm -f $a; \
504 echo .so ${m##*/} > $a; \
505 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
506 done; \
4f044018 507 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
508 fi; \
509 done; \
728ad671
JB
510 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
511 echo "Compress info pages: %{_infodir}"; \
512 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
513 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
514 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 515 fi; \
53d5af13 516}; __spec_install_post_compress_docs } }
9c404149
AM
517
518#-----------------------------------------------------------------
519# Strip executable binaries and shared object files
520#
521# Requires: find, awk, strip, cut, xargs
522#
a2ad2754
JB
523# Special macros which affect this process:
524#%no_install_post_strip 1 # disable stripping at all
525#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
526#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
527#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
528#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
529#
9c404149 530%__spec_install_post_strip {%{!?debug: \
53d5af13 531%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 532if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
533 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
534 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
535 if [ "$modulelist" ]; then \
536 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 537 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
538 echo "$modulelist" | xargs -l512 chmod u+w; \
539 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
540 echo "DONE"; \
541 fi; \
eea64748 542 fi; \
0ac49134 543 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
544 if [ -n "$filelist" ]; then \
545 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
546 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
547 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 548 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 549 if [ -n "$elfexelist" ]; then \
4d5370ac 550 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
551 chmod u+w $elfexelist; \
552 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
553 echo "DONE"; \
554 fi; \
555 if [ -n "$elfsharedlist" ]; then \
4d5370ac 556 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
557 chmod u+w $elfsharedlist; \
558 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
559 echo "DONE"; \
560 fi; \
561 if [ -n "$archiveslist" ]; then \
4d5370ac 562 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
563 chmod u+w $archiveslist; \
564 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
565 echo "DONE"; \
566 fi; \
98a06bad 567 fi; \
0ac49134
ER
568 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
569 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
570 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 571 if [ -n "$filelist_all" ]; then \
4d5370ac 572 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 573 chmod u+w $filelist_all; \
f89ccb5f 574 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 575 echo "DONE"; \
9c404149 576 fi; \
f89ccb5f 577 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 578 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 579 chmod u+w $filelist_unneeded; \
f89ccb5f 580 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 581 echo "DONE"; \
8f74418b 582 fi; \
f89ccb5f 583 if [ -n "$filelist_debug" ]; then \
4d5370ac 584 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 585 chmod u+w $filelist_debug; \
f89ccb5f 586 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 587 echo "DONE"; \
9f0d4f36 588 fi; \
53d5af13 589fi; }; __spec_install_post_strip } } }
3241033b 590
fc5d7e20 591#-----------------------------------------------------------------
592# remove all RPATH from executable binaries and shared object files
593#
594# Requires: find, awk, cut, xargs, chrpath, uname
595#
a2ad2754
JB
596# Special macros which affect this process
597#%no_install_post_chrpath 1 # disable chrpath at all
598#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
599#
fc5d7e20 600%__spec_install_post_chrpath {%{!?debug: \
53d5af13 601%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 602if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 603 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 604 if [ -n "$files" ]; then \
d5517264 605 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 606 fi; \
98a06bad 607 if [ -n "$objs" ]; then \
4d5370ac 608 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
609 echo "$objs" | \
610 while read file; do \
611 rpath= ; \
612 chmod u+w "$file"; \
5541bf26 613 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
614 case $dir in \
615 '$ORIGIN' ) \
616 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
617 else rpath="$rpath:$dir" ; fi ; \
618 continue ; \
619 ;; \
620 esac ; \
f9abaddb
AM
621 newdir=$(readlink -m "$dir"); \
622 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
623 case $dir in \
624 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
625 echo "remove-rpath: $dir in $file"; \
626 ;; \
627 * ) \
628 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
629 else rpath="$rpath:$dir" ; fi ; \
630 ;; \
631 esac ; \
632 done ; \
633 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
634 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
635 done; \
636 fi; \
53d5af13 637fi; }; __spec_install_post_chrpath } } }
3241033b 638
611a25d5 639# vim: "
640
d366d7e0
AM
641#-----------------------------------------------------------------
642# Find all shared object files with unresolved symbols. Warn
643# and terminate if any found (termination can be turned off by define).
644#%no_install_post_check_so 1
ff8c88f6 645#%skip_post_check_so libwithunresolvedok.so.*
d366d7e0
AM
646%__spec_install_post_check_so { \
647 __spec_install_post_check_so() { \
648 fail=0; \
649 printf "Searching for shared objects with unresolved symbols..."; \
34906a2d 650 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
b6c601e3 651 %{?skip_post_check_so:awk -v "file=$f" 'BEGIN { split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") exit(1); } }' || continue;} \
7df9ddfc 652 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
d366d7e0
AM
653 done ; \
654 echo " DONE"; \
603b05a4 655 %{!?no_install_post_check_so:return $fail;} \
d366d7e0
AM
656}; __spec_install_post_check_so }}
657
d72c185f 658#-----------------------------------------------------------------
ccb8ae8d 659# Find and gzip all kernel modules
660#
661# Requires: find
662#
fe6c4bdd 663#%no_install_post_compress_modules 1
ccb8ae8d 664%__spec_install_post_compress_modules { \
53d5af13 665%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 666 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 667 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
668 if [ "$q" ]; then \
669 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
670 echo "$q" | xargs -r %{__gzip} -9nf; \
671 echo "DONE"; \
672 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
673 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
674 fi; \
3241033b 675 fi; \
53d5af13 676}; __spec_install_post_compress_modules } }
9c404149 677
ef64802f
ER
678# Remove common Perl files we don't package
679%__spec_install_post_perl_clean {\
680%{!?no_install_post_perl_clean: \
681%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
682} }
683
83094b62 684#-----------------------------------------------------------------
0e4cb4dd 685# Update GConf2 schemas
83094b62 686#
687# Requires: GConf2
688#
46885239 689%gconf_schema_install() \
307ac6c9
ER
690 umask 022; \
691 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
692 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 693%{nil}
46885239 694
695%gconf_schema_uninstall() \
24336a54 696if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 697 umask 022; \
24336a54
ER
698 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
699 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 700fi; \
f93109a0 701%{nil}
702
703#-----------------------------------------------------------------
704# Update desktop MIME database
c0a4caa0 705# requires: desktop-file-utils
c3bcd10e 706%update_desktop_database() {{ \
f93109a0 707 umask 022; \
fb59e475 708 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
709};} \
710%{nil}
f93109a0 711
c3bcd10e
ER
712%update_desktop_database_post %update_desktop_database
713
714%update_desktop_database_postun() {{ \
f27cf2fd 715if [ "$1" = "0" ]; then \
c00bf95c 716 %update_desktop_database \
f27cf2fd 717fi; \
c00bf95c
MB
718};} \
719%{nil}
f93109a0 720
fb59e475 721#-----------------------------------------------------------------
722# Update shared MIME info database
723# requires: shared-mime-info
724#
c3bcd10e 725%update_mime_database() {{ \
fb59e475 726 umask 022; \
727 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
728};} \
729%{nil}
fb59e475 730
731#-----------------------------------------------------------------
732# Update icon cache
733# requires: gtk+
734#
c3bcd10e 735%update_icon_cache() {{ \
fb59e475 736 umask 022; \
072f4b80 737 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
738};} \
739%{nil}
fb59e475 740
f93109a0 741#-----------------------------------------------------------------
742# Update scrollkeeper database
743# requires: scrollkeeper
744#
745%scrollkeeper_update_post() \
f93109a0 746 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 747%{nil}
f93109a0 748
749%scrollkeeper_update_postun() \
f27cf2fd 750if [ "$1" = "0" ]; then \
f93109a0 751 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 752fi; \
f93109a0 753%{nil}
754
9c404149
AM
755#-----------------------------------------------------------------
756# post %install sequence:
757# - autodeps exceptions
758# - compress all man and info pages,
759# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 760# - compress kernel modules if any
9c404149
AM
761
762###################################################################
763# Requires/Provides automation
3e202b06 764# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 765#
2892b5df
JB
766%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
767%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
768%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
769%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
770%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 771
338726a6
JB
772#%_noautocompressdoc %{nil}
773#
8f74418b
MM
774%_missing_doc_files_terminate_build 1%{nil}
775%_unpackaged_files_terminate_build %{nil}
8781dc74 776# (X)emacs support
d77dcb61 777%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
778%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
779%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 780
02b58f60
JK
781%__php_provides %{nil}
782%__php_requires %{nil}
783%__perl_provides %{nil}
784%__perl_requires %{nil}
fa3497cd 785%__mono_provides %{nil}
786%__mono_requires %{nil}
25043cd4
AF
787
788# Perl specific macro definitions.
c94807f3
ER
789%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
790%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
791%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
792%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
793%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
794%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 795
45c00b39 796# Ruby
c94807f3
ER
797%__ruby /usr/bin/ruby
798%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
799%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
800%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
801%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
802%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
803%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
804%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 805%ruby_rdocdir /usr/share/rdoc
c94807f3 806%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
807%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
808%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 809
7ccf7643 810%php_pear_dir /usr/share/pear
7813c433 811%php_data_dir /usr/share/php
c94807f3
ER
812%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
813%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
814%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 815
0c5d1b9b 816# extract php/zend api versions
c94807f3 817%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
e0d35dd1 818%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
c94807f3
ER
819%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
820%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
821%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
822%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
823%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
d9ca5910
ER
824%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
825# "_ts" if ZTS enabled, empty otherwise
826%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
c1b2705c
ER
827
828# helper macro
f952c0f3 829%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
830
831# macros for public use
832# for php extensions (php-pecl)
68b68193 833%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 834%{__php_api_requires zend_module_api} \
f952c0f3 835%{__php_api_requires -v %php_major_version debug php_debug} \
e2bc6159 836%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
68b68193 837
c1b2705c
ER
838# for zend extensions
839%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 840%{__php_api_requires zend_extension_api} \
f952c0f3 841%{__php_api_requires -v %php_major_version debug php_debug} \
e2bc6159 842%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
c1b2705c 843
934c685f
ER
844# for php pdo modules (php-pecl-PDO_*)
845%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
846
6c3b8203
ER
847# for using PHP post scripts. for PHP >= 5.0
848%php_webserver_restart \
849[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 850[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
8e2cfc36 851if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
852 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
853 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
854 %service -q php-fcgi restart \
855 fi \
856fi \
8e2cfc36
ER
857if [ -x /etc/rc.d/init.d/php-fpm ]; then \
858 %service -q php-fpm restart \
859fi \
6c3b8203
ER
860%{nil}
861
862# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
863%php4_webserver_restart \
864[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 865[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
8e2cfc36 866if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
867 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
868 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
869 %service -q php-fcgi restart \
870 fi \
871fi \
6c3b8203
ER
872%{nil}
873
578e9248 874# X.org helper macros
434ab5a2
ER
875%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
876%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
877
c94807f3
ER
878%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
879%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
880%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
881%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
882%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
611a25d5 883# vim: '
578e9248 884
434ab5a2 885%requires_xorg_xserver_extension \
97486460
AM
886%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
887%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
888%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
889%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
890%{nil}
891
892%requires_xorg_xserver_xinput \
97486460
AM
893%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
894%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
895%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
896%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
897%{nil}
898
899%requires_xorg_xserver_font \
97486460
AM
900%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
901%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
902%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
903%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
904%{nil}
905
906%requires_xorg_xserver_videodrv \
97486460
AM
907%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
908%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
909%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
910%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 911%{nil}
578e9248 912
15d7cc4a
ER
913# TCL specific macro definitions.
914# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
915%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
916%tcl_sitearch %{_libdir}/tcl%{tcl_version}
917%tcl_sitelib %{_datadir}/tcl%{tcl_version}
918
25043cd4
AF
919# Python specific macro definitions.
920# python main version
2383a9da 921%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
922
923# directories
2383a9da 924%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 925%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 926%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 927%py_incdir /usr/include/python%{py_ver}
7ccf7643 928%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 929%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 930%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
931
932# pure python modules compilation
3241033b 933%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 934
3241033b 935%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
936
937# Software written in Python language require Python with main version
e63cd81d 938%pyrequires_eq() Requires: %1
25043cd4 939
4bf34b55
AF
940# Python 3.x
941# python main version
e9f00395 942%__python3 python3
4bf34b55
AF
943%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
944
945# directories
946%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
947%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
948%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
949%py3_incdir /usr/include/python%{py3_ver}
950%py3_sitedir %{py3_libdir}/site-packages
951%py3_sitescriptdir %{py3_scriptdir}/site-packages
952%py3_dyndir %{py3_libdir}/lib-dynload
953
954# pure python modules compilation
955%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
956
957%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
958
f12c2314 959# Hardlink binary identical .pyc and .pyo files
f12c2314 960%__spec_install_post_py_hardlink {\
53d5af13 961%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
962local a b c=0 t=0; \
963if [ -d "$RPM_BUILD_ROOT" ]; then \
964 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
965 while read a; do \
966 b="${a%.pyc}.pyo"; \
967 if cmp -s "$a" "$b"; then \
968 ln -f "$a" "$b"; \
969 c=$((c + 1)); \
970 fi; \
971 t=$((t + 1)); \
972 done < __rpm_pyc; \
973 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
974 rm -f __rpm_pyc; \
975fi; \
53d5af13 976}; __spec_install_post_py_hardlink } }
f12c2314 977
9227b3f9 978# remove python sources, so that check-files won't complain
f12c2314 979%py_postclean() \
0f82e280 980for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 981 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
982done \
983%{nil}
984
4bf34b55
AF
985%py3_postclean() \
986for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
987 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
988done \
989%{nil}
990
0fc5cff8 991# depmod macro
992%depmod() { \
f6148427 993umask 022; \
0fc5cff8 994if [ -e /boot/System.map-%1 ]; then \
3241033b 995 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 996else \
3241033b
ER
997 if [ -e /boot/System.map ]; then \
998 /sbin/depmod -a -F /boot/System.map %1; \
999 else \
1000 /sbin/depmod -a %1; \
1001 fi \
0fc5cff8 1002fi; \
1003}
1004
2afc6e64 1005# XMMS specific macros
c94807f3
ER
1006%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1007%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1008%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1009%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1010%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1011%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1012%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1013%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1014%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1015%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1016
eb41c1ce 1017%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
d1537778 1018
848c0d68 1019# user/group checking macros
1020#
1021# Usage:
1022# %userremove myuser
1023#
1024%userremove /usr/lib/rpm/user_group.sh user del
1025%groupremove /usr/lib/rpm/user_group.sh group del
1026#
1027# Usage:
1028# if %usertestrm myuser; then
1029# /usr/sbin/userdel -r myuser
1030# Note:
1031# use these macros only if you need to call userdel/groupdel with
1032# a non-standard option or take an extra action; otherwise use the
1033# %userremove/%groupremove macros
1034#
1035%usertestrm /usr/lib/rpm/user_group.sh user testrm
1036%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
1037# user group membership management macros
1038#
1039# Usage:
efbc7726 1040# %addusertogroup [-q] myuser agroup
08d9b1f6 1041#
efbc7726
ER
1042# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1043#
1044# Requirements:
1045# BuildRequires: rpmbuild(macros) >= 1.515
2b29e157
ER
1046%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1047%{nil}
72fcfcb3 1048
1049# banner support (useful in {pre,post}{,un} and triggers)
1050#
1051# Usage:
aa41c920 1052# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 1053# the banner text, the banner text
aa41c920
ER
1054# the banner text, and following line
1055#EOF
1056# You can use any form of here-document, <<'EOF' <<-EOT will do.
1057# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1058#
72fcfcb3 1059# -a - append to the banner
a8b9562a 1060# -e - send to stderr instead of stdout
628754cb 1061# -n - no show banner (overrides -t)
1062# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
1063#
1064# Tests:
1065# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1066# rpm -E 'date | %banner -e banner' > m; sh -x m
1067#
afb54f6c 1068%banner(aent:) ( \
1b334fe4 1069RPM_SCRIPTVERBOSITY=5 \
1070[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1071if [ -x /usr/bin/banner.sh ]; then \
aa41c920 1072 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 1073else \
a8b9562a 1074 CMD="cat%{-e: >&2}" \
1b334fe4 1075fi \
276a7b45
ER
1076eval $CMD %{?2:%2}%{?3: %3}) \
1077%{nil}
628754cb 1078
990bd03f 1079# useradd/groupadd macros
4c73bc69 1080# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
1081#
1082# Usage:
1083# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1084# [-g initial_group] [-G group[,...]] login
1085#
1086# -u uid. REQUIRED
1087# -g gid/group. REQUIRED
1088# -s defaults to /bin/false
1089# -d defaults to /usr/share/empty
1090# -c No default
1091# -r is accepted but ignored (it's always set)
6bd4c218 1092# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
1093# rpm specific flags
1094# -P package name. defaults to %{name}
1095#
90627280 1096%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
1097%{!-u:%{error:useradd: Required argument -u missing}} \
1098%{!-g:%{error:useradd: Required argument -g missing}} \
1099%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
1100if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1101 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1102 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1103 exit 1 \
1104 fi \
1105else \
1106 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1107 /usr/sbin/useradd \\\
b5a7d552 1108 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
1109 -u %{-u*} \\\
1110 -r \\\
1111 -d %{-d*}%{!-d:/usr/share/empty} \\\
1112 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 1113 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
1114 -g %{-g*} \\\
1115 %{-M} \\\
1116 %{-G:-G %{-G*}} \\\
1aac682a 1117 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 1118 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280 1119fi;
611a25d5 1120# vim: "
90627280 1121
90627280
ER
1122# Usage:
1123# %groupadd [-P package] [-g gid] group
1124#
1125# -g gid. REQUIRED
1126#
1127# Sample:
1128# %groupadd -P %{name}-base -g %{gid} %{name}
1129
1130%groupadd(g:P:rfo) \
9ba02ba9
ER
1131%{!-g:%{error:groupadd: Required argument -g missing}} \
1132%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 1133if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1134 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1135 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1136 exit 1 \
1137 fi \
1138else \
1139 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1140 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1141 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1142fi;
7cb77741 1143
7c50f037 1144# webapp macros
4c73bc69 1145# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1146#
1147# The config is installed/removed inside trigger, this means that you can any
1148# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1149# updated. if you don't need the config for various reason for specific
35663282
ER
1150# webserver, just remove the symlink from config directory using webapp
1151# program. the trigger will not recreate the symlink on upgrades. In other
1152# words the config is linked to webserver config directory on first install of
1153# PACKAGE or WEBSERVER.
1154#
7c50f037
ER
1155# Add package's webserver config to webserver webapps dir.
1156# Usage:
aea687a7 1157# %webapp_register [-f] WEBSERVER WEBAPP
35663282 1158#
aea687a7 1159%webapp_register(f) \
35663282 1160%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
aea687a7 1161if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
35663282
ER
1162 /usr/sbin/webapp register %1 %2\
1163fi\
694a8f2e 1164# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1165if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1166 %{expand:%service -q %%1 reload}\
35663282
ER
1167fi\
1168%{nil}
1169
1170# Remove package's config from webserver webapps dir.
35663282 1171# Usage:
531c0efc
ER
1172# %webapp_register [-f] WEBSERVER WEBAPP
1173%webapp_unregister(f) \
35663282
ER
1174%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1175# remove link if either of the packages are gone \
5d3a09a3 1176if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1177 /usr/sbin/webapp unregister %1 %2\
16897aea 1178 %{expand:%service -q %%1 reload}\
35663282
ER
1179fi \
1180%{nil}
1181
462b26fa 1182# service macro.
4c73bc69 1183# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1184#
1185# calls usual service restart on package %post, but skips the restart if
1186# administrator has disabled automatic service restarts in either global
1187# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1188#
462b26fa 1189# Usage:
7377b5ca 1190# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1191#
a0bbe604 1192# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1193# -n NOOP mode, do not actually restart service
462b26fa 1194#
7377b5ca
ER
1195# Requirements:
1196# BuildRequires: rpmbuild(macros) >= 1.268
1197# Requires: rc-scripts
1198# -n option:
1199# BuildRequires: rpmbuild(macros) >= 1.450
1200%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1201
1202
f9aa75bf
ER
1203# Java macros. based on jpackage macros.java
1204#
1205# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1206%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1207
1208# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1209%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1210
1211# Root directory for all Java VM/SDK/JRE's private things.
1212%_jvmprivdir %{_libdir}/jvm-private
1213
1214# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1215%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1216
1217# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1218%_jvmdatadir %{_datadir}/jvm
1219
1220# Root directory for all configurations parts of Java VM/SDK/JRE's
1221%_jvmsysconfdir %{_sysconfdir}/jvm
1222
1223# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1224%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1225
1226# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1227%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1228
1229# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1230%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1231
1232# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1233%_jnidir %{_libdir}/java
f9aa75bf 1234
ed644e79
JK
1235
1236# JDK selection. Set this to name of the JDK implementation to use
1237# insead of the system default
1238#%use_jdk icedtea6
1239
1240# expands to the value with right jdk for BuildRequires header
1241# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1242# The requirement will not replace current 'default' JDK
1243%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1244
1245%buildrequires_jdk BuildRequires: %required_jdk
1246
1247%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1248
e0e23dcd 1249%_javasrcdir %{_usrsrc}/java
1250
a9254650 1251%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1252%jar %{java_home}/bin/jar
ed644e79 1253%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
fe6c4bdd
ER
1254%javac %{java_home}/bin/javac
1255%javadoc %{java_home}/bin/javadoc
6aedae62 1256
fe6c4bdd 1257%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1258
1259%jpackage_script() \
3ca65b87
ER
1260install -d $RPM_BUILD_ROOT%{_bindir}\
1261cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1262#!/bin/sh\
1263#\
1264# %{name} script\
1265# JPackage Project <http://www.jpackage.org/>\
1266\
1267# Source functions library\
1268. %{_javadir}-utils/java-functions\
1269\
1270# Source system prefs\
3ca65b87 1271if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1272 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1273fi\
1274\
1275# Source user prefs\
3ca65b87
ER
1276if [ -f $HOME/.%{name}rc ]; then\
1277 . $HOME/.%{name}rc\
6aedae62
ER
1278fi\
1279\
1280# Configuration\
1281MAIN_CLASS=%1\
1282BASE_FLAGS=%2\
1283BASE_OPTIONS=%3\
3ca65b87 1284BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1285\
1286# Set parameters\
1287set_jvm\
3ca65b87
ER
1288set_classpath $BASE_JARS\
1289set_flags $BASE_FLAGS\
1290set_options $BASE_OPTIONS\
6aedae62
ER
1291\
1292# Let's start\
3ca65b87 1293run "$@"\
6aedae62
ER
1294EOF
1295
06f11871
ER
1296# jpackage 1.7
1297# Directory for maven depmaps
1298#
1299%_mavendepmapdir /etc/maven
1300%_mavendepmapfragdir /etc/maven/fragments
1301
1302#
1303# add_to_depmap adds an entry to the depmap. The arguments are:
1304#
1305# %1 the original groupid
1306# %2 the original artifact id
1307# %3 the version
1308# %4 the new groupid
1309# %5 the new artifactid
1310#
1311
1312%add_to_maven_depmap() \
1313install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1314cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1315<dependency>\
1316 <maven>\
1317 <groupId>%1</groupId>\
1318 <artifactId>%2</artifactId>\
1319 <version>%3</version>\
1320 </maven>\
1321 <jpp>\
1322 <groupId>%4</groupId>\
1323 <artifactId>%5</artifactId>\
1324 <version>%3</version>\
1325 </jpp>\
1326</dependency>\
1327\
1328EOF\
1329%{nil}
1330
1331#==============================================================================
1332#
1333# update_maven_depmap updates the main maven depmap
1334#
1335%update_maven_depmap() \
1336echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1337if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1338cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1339fi\
1340echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1341
02c5f99a 1342# JAVA macros specific for PLD
1343
1344# Directory for tomcat context configuration files
1345%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
06f11871 1346
89c2423f 1347# Tomcat cache path
1348%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1349
1350# Clear tomcat cache
1351# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1352#
1353# Usage:
1354# %%tomcat_clear_cache appname
1355#
e09b1b1b 1356# Call this script in %postun scriptlet. It will remove compiled jsps related to
89c2423f 1357# given app.
1358#
1359%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1360
59d3ebe9 1361# PEAR install macros
4c73bc69 1362# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1363#
1364# Usage:
f7ecf326 1365# %%pear_package_setup ...
dfce8b19 1366#
59d3ebe9 1367# -a # - also unpack SOURCE#. for PEAR bootstrapping
43d992d6 1368# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
59d3ebe9 1369# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1370# -D - pass -D to %setup (so the build dir is not removed)
1371# -c - register channel from local channel.xml file
11a40e7b 1372# -d - pass -d arg to pearcmd
dfce8b19
ER
1373#
1374# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1375# destination hierarchy. you should copy the tree to buildroot after
1376# patching/reorganizing with %%pear_package_install.
1377#
1378# additionally BUILDROOT is stripped from files and files are converted to UNIX
1379# line endings.
1380#
1381# the pear install process output is recorded to install.log, you should put it
8763f51e 1382# to %%doc for later debug or just for information.
dfce8b19
ER
1383#
1384# additionally additional-packages.txt is produced if it was detected that the
1385# package has optional dependencies. the file format is suitable of displaying
1386# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1387# automatically added for this file.
59d3ebe9
ER
1388
1389
1390# records install.log and transforms PEAR names to PLD Linux rpm package names.
1391%__pear_install_log \
1392tee install.log \
1393# make post message of optional packages \
5ad4663a 1394grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1395if [ -s optional-packages.txt ]; then \
1396 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1397else \
1398 rm -f optional-packages.txt \
1399fi \
1400%{nil}
1401
e98e79d4
ER
1402# Command invoking PEAR CLI
1403# Same as /usr/bin/pear, except we force GMT timezone
1404%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT %{php_pear_dir}/pearcmd.php
59d3ebe9 1405
11a40e7b 1406%pear_install(a:d:n:zD) \
59d3ebe9 1407%__pear \\\
f7ecf326 1408 -c %{builddir}/pearrc \\\
dfce8b19 1409 -d doc_dir=/docs \\\
f7ecf326
ER
1410 -d temp_dir=/tmp \\\
1411 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1412 -d bin_dir=%{_bindir} \\\
1413 -d data_dir=%{php_pear_dir}/data \\\
1414 -d test_dir=%{php_pear_dir}/tests \\\
11a40e7b 1415 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
dfce8b19 1416 install \\\
59d3ebe9 1417 --packagingroot=%{builddir} \\\
dfce8b19
ER
1418 --offline \\\
1419 --nodeps \\\
1420 %{-f:--force} \\\
67a089ff 1421 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1422 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1423%{nil}
1424
1425# The main macro.
1426# using this macro will append optional-packages.txt to the nocompressdoc list
1427# as it's displayed to user after package install. and adding additional gzip
1428# dep is just waste ;)
11a40e7b 1429%pear_package_setup(a:d:n:zDc:) \
43d992d6 1430%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
67a089ff
ER
1431%define builddir %{_builddir}/%{srcdir} \
1432%setup -q -c -T %{-D:-D} -n %{srcdir} \
a4b4c90f 1433%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
67a089ff 1434%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1435%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1436%pear_install \
59d3ebe9 1437%{-z:cd ..} \
a4b4c90f 1438%{__tar} --wildcards -zvxf %{S:0} package*.xml \
59d3ebe9 1439cat %{-z:$_N/}.install.log | %__pear_install_log \
208a11f6 1440%undos -f php,html,js,xml \
dfce8b19
ER
1441%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1442%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1443%{nil}
1444
7bef60e8 1445# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1446# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1447%pear_package_install() \
1448cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1449find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1450# help the developer out a little: \
1451if [ -f _noautoreq ]; then \
1452 echo "AutoReqdep detected:" \
1453 echo "_noautoreq $(cat _noautoreq)" \
1454fi \
1455%{nil}
1456
cc8d4be7
ER
1457# Print optional package info for pear packages
1458# Author: Elan Ruusamäe <glen@pld-linux.org>
1459# Usage:
1460# %post -p <lua>
1461# %%pear_package_print_optionalpackages
1462#
1463# Requirements:
1464# BuildRequires: rpmbuild(macros) >= 1.571
1465%pear_package_print_optionalpackages \
1466f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1467if f then \
1468 for l in f:lines() do print(l); end \
1469end \
1470%{nil}
1471
0d5dd00c
ER
1472
1473# Register OpenLDAP schema.
4c73bc69 1474# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1475#
1476# Usage:
1477# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1478#
1479# -d specify dependant schemas, separated by comma
1480#
1481%openldap_schema_register(d:) \
1482for schema in %*; do \
1483 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1484 %{__sed} -i -e " \
1485 /^include.*local.schema/{ \
1486 iinclude\\t $schema\
1487 } \
1488 " /etc/openldap/slapd.conf \
1489 fi \
1490done \
1491# enable dependant schemas \
1492if [ "%{-d*}" ]; then \
1493 %{__sed} -i -e ' \
1494 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1495 s/^#// \
1496 }' /etc/openldap/slapd.conf \
1497fi \
1498%{nil}
1499
1500# Unregister OpenLDAP schema.
4c73bc69 1501# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1502#
1503# Usage:
1504# %%openldap_schema_unregister %{schemadir}/horde.schema
1505#
1506%openldap_schema_unregister() \
1507for schema in %*; do \
1508 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1509 %{__sed} -i -e " \
1510 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1511 # for symmetry it would be nice if we disable enabled schemas in post, \
1512 # but we really can not do that, it would break something else. \
1513 " /etc/openldap/slapd.conf \
1514 fi \
1515done \
1516%{nil}
1517
b0bc2936 1518%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1519
dcc6baf7 1520
1521# Build modules for kernels 2.6
1522# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1523#
1524# Usage:
aa559e46 1525# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1526#
1527# remember that proper Makefile is still required
1528# Options:
990bd03f 1529# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1530# without .ko extension, may be placed in subdirectory
aa559e46 1531# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1532# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1533# -c -- do not execute make clean
dcc6baf7 1534# <additional arguments> -- all additional arguments will be passed to
1535# make modules
1536#
1537# Additional patching supported via here document. Try:
1538# %build_kernel_modules -m module <<'EOF'
1539# your patch script here
1540# EOF
1541# Don't use it unless patching depends on config options.
1542
1543# Developer note: don't touch it unless you know how to handle '\'.
1544# - \ in script expands to nothing
1545# - \\\ in script expands to \
566398b4 1546# - \\\ inside definition expands to nothing
dcc6baf7 1547# - \\\\\\\ inside definition expands to \
1548# - in last line \ has to touch arguments so arguments passing
1549# in new lines (using \) will be supported
1550
5a81d83e 1551%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1552%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1553 \
1554%define Opts \\\\\\\
1555%if "%{_target_base_arch}" != "%{_arch}" \\\
1556 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1557 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1558 %else \\\
1559 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1560 %endif \\\
1561%else \\\
88608ef7 1562 CC="%{kgcc}" \\\
dcc6baf7 1563%endif \
88608ef7 1564%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1565 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1566 \
e364bc26 1567%{?-C:cd %{-C*}} \
dcc6baf7 1568compile() { \
ba9de9b2
ER
1569 local L="<" PATCH_SH; \
1570 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1571 set -e -x \
730239f9 1572 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1573 \
730239f9 1574for cfg in ${cfgs:-dist}; do \
dcc6baf7 1575 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1576 \
c546f6fb 1577 rm -rf o \
ec8cb195 1578 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
dcc6baf7 1579 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1580 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
ec8cb195
AM
1581 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1582 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
a2a36b0c 1583 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
ec8cb195
AM
1584 else \
1585 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1586 fi \
dcc6baf7 1587 \
1588 set +x \
1589 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1590 set -x \
1591 \
c768535c 1592 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1593 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1594 %{-p*} %{-P*} \\\
1595 %{MakeOpts} \
1596 %else \
1597 install -d o/include/config \
1598 touch o/include/config/MARKER \
588f1b0b 1599 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1600 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1601 %endif \
1602 \
5a81d83e 1603 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1604 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1605 ${1+"$@"} \\\
5a81d83e 1606 M=$PWD %{MakeOpts}} \
f635907b 1607 \
dcc6baf7 1608 %{__make} -C %{_kernelsrcdir} modules \\\
1609 ${1+"$@"} \\\
1610 M=$PWD %{MakeOpts} \
1611 \
1612 for MODULE in {%{-m*},}; do \
1613 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1614 done \
1615done \
aa559e46 1616%{?-C:cd -} \
dcc6baf7 1617} \
1618compile %{*}\
1619%{nil}
1620
1621
1622# Install kernel modules built by %build_kernel_modules
1623# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1624#
1625# Usage:
1626# %install_kernel_modules -m <modules> -d <directory>
1627#
1628# Options:
990bd03f 1629# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1630# without .ko extension, may be placed in subdirectory
1631# -d <directory> (required) -- in what subdirectory modules should be
1632# installed (eg. misc, kernel/drivers/net)
1633# -s <suffix> -- suffix to use when installing modules, useful when module
1634# with same name exists in kernel already
1635# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1636# for defining aliases, only useful with -s
dcc6baf7 1637
1638%install_kernel_modules(m:d:s:n:) \
1639%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1640%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1641%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1642 \
1643%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1644%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1645 \
b279feda 1646__install_kernel_modules() { \
730239f9 1647local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1648 \
1649for MODULE in {%{-m*},}; do \
1650 [ -n "${MODULE}" ] || continue \
730239f9
ER
1651 for cfg in ${cfgs:-dist}; do \
1652 [ "$cfg" = smp ] && suf=smp || suf= \
1653 MNAME=${MODULE##*/} \
1654 install -D ${MODULE}-$cfg.ko \\\
1655 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1656 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1657 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1658 >> %{ModprobeD}$suf/%{-n*}.conf} \
1659 done \
dcc6baf7 1660done \
b279feda 1661} \
1662__install_kernel_modules \
dcc6baf7 1663%{nil}
1664
fa65356c 1665# patchset macros
4c73bc69 1666# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1667#
1668# Usage:
1669# %patchset_source -f <seq(1) format> <start> [<end>]
1670# %patchset_patch <start> [<end>]
1671#
1672# If <end> is omited, it is assumed to be <start>.
1673#
1674# For example in preamble:
1675# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1676# and in %prep:
1677# %patchset_patch 33 44
1678
1679# generate SourceX urls from range START STOP
1680# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1681# The sources start from 10000
e91610db 1682%patchset_source(f:b:) %(
44f733ef 1683 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1684 start=$(expr $base + %1);
1685 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1686 # we need to call seq twice as it doesn't allow two formats
1687 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1688 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1689 paste %{tmpdir}/__ps{1,2};
1690 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1691) \
1692%{nil}
fa65356c
ER
1693
1694# apply sources from %patchset_source
1695# -p specify -pX for %patch line
1696# -b base offset: defaults to 10000
1697%patchset_patch(f:p:b:) %(
44f733ef 1698 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1699 start=$(expr $base + %1);
1700 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1701 echo ": patchset_patch %1%{?2: to %2}";
1702 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1703) \
1704%{nil}
fa65356c 1705
5730b44b 1706# browser plugins v2
4c73bc69 1707# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1708#
1709# Usage:
1710# %browser_plugins_add_browser <name> -p <plugindir>
1711#
1712# <name> (required) -- name of the browser. usually %{name}.
1713# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1714# -b -- default blacklists
1715# -a <arch> override arch
5730b44b
ER
1716#
1717# Example:
1718# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1719
1720%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1721%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1722%update_browser_plugins /usr/sbin/update-browser-plugins || :
1723
02ebf70f 1724%browser_plugins_add_browser(p:b:a:) \
9efd458e 1725 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1726 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1727 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1728 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1729 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1730 %{-b:cat >> $blacklist_file %{-b*}} \
1731%{nil}
1732
ad17b654
ER
1733# Helper for LUA.
1734# split string separated by space into quoted list
1735#
4c73bc69 1736# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1737#
1738# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1739%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1740
1741# adjust /etc/shells by adding and removing shells from there
4c73bc69 1742# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1743#
1744# Usage:
d9b789d9
ER
1745# %post -p <lua>
1746# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1747#
d9b789d9
ER
1748# %preun -p <lua>
1749# if arg[2] == 0 then
1750# %lua_remove_etc_shells /bin/bash /bin/rbash
1751# end
7377b5ca
ER
1752#
1753# Requirements:
d9b789d9
ER
1754# BuildRequires: rpmbuild(macros) >= 1.462
1755#
ad17b654 1756
d9b789d9 1757%lua_add_etc_shells() \
ad17b654
ER
1758t = {}\
1759f = io.open("/etc/shells", "r")\
1760if f then\
1761 for l in f:lines() do t[l]=l; end\
1762 f:close()\
1763end\
1764for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1765 if not t[s] then\
b8c0bc18 1766 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1767 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1768 end\
1769end\
1770%{nil}
1771
d9b789d9
ER
1772%lua_remove_etc_shells() \
1773t = {}\
1774f = io.open("/etc/shells", "r")\
1775if f then\
1776 for l in f:lines() do t[l]=l; end\
1777 f:close()\
1778end\
1779for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1780 print("Removing "..l.." from /etc/shells")\
1781 t[l] = nil\
1782end\
1783s=""\
1784for _, l in pairs(t) do\
1785 s=s..l.."\\n"\
1786end\
1787io.open("/etc/shells", "w"):write(s)\
1788%{nil}
1789
1790# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1791#
1792# Author: Elan Ruusamäe <glen@pld-linux.org>
1793#
1794# Usage:
1795# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1796# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1797#
1798# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1799#
1800# Requirements:
1801# BuildRequires: rpmbuild(macros) >= 1.429
1802#
1803%add_etc_shells(p) %{-p:<lua>}\
1804%{expand:%%lua_add_etc_shells %*}\
1805%{nil}
1806
ad17b654 1807%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1808%{-p:if arg[2] == 0 then}\
d9b789d9 1809%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1810%{-p:end} \
ad17b654
ER
1811%{nil}
1812
75bd6249
ER
1813# Check syntax for Python files
1814#
1815# Author: Elan Ruusamäe <glen@pld-linux.org>
1816# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1817#
1818# Usage:
1819# %py_lint src
1820#
1821# Requirements:
1822# BuildRequires: python
1823# BuildRequires: rpmbuild(macros) >= 1.469
1824
1825%py_lint() \
1826__py_lint() { \
1827find "$@" -type f -name '*.py' | python -c ' \
1828import sys \
1829import compiler \
1830\
1831err = 0\
1832for f in sys.stdin: \
1833 fd = open(f.strip()) \
1834 c = fd.read() \
1835 fd.close() \
1836 try: \
1837 compiler.parse(c) \
1838 except SyntaxError, e: \
1839 print "py_lint: %s: %s" % (f.strip(), e) \
1840 err = err + 1\
1841\
1842if err: \
1843 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1844 sys.exit(1) \
1845else: \
1846 print >> sys.stderr, "py_lint: Found no syntax errors." \
1847' \
1848}; __py_lint %* \
1849%{nil}
1850
f602e4a0 1851# Undos files
1852#
1853# Author: Paweł Zuzelski <pawelz@pld-linux.org>
0217c63b 1854# Author: Elan Ruusamäe <glen@pld-linux.org>
f602e4a0 1855#
1856# Usage:
1857# %undos list_of_files
0217c63b
ER
1858# %undos -f EXT[,EXT]
1859# %undos -i -f EXT[,EXT]
1860#
1861# -f EXT[,EXT] - find(1) files by extensions
1862# -i - case insensitive file search
1863#
1864# Example:
1865# Un-DOS all *.js, *.css files
1866# %undos -f js,css
1867# Un-DOS all *.js, *.JS files
1868# %undos -f js -i
1869# undos all Makefiles
1870# %{__find} -name Makefile | xargs %undos
f602e4a0 1871#
1872# Requirements:
1873# BuildRequires: sed >= 4.0
81a64c94 1874# BuildRequires: rpmbuild(macros) >= 1.565
f602e4a0 1875
0217c63b 1876# NB: make sure this macro stays on one line
81a64c94
ER
1877# NB: make sure it includes newline escape
1878%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1879%{nil}
f602e4a0 1880
2f79ae5a
ER
1881# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1882#
1883# Author: Elan Ruusamäe <glen@pld-linux.org>
1884#
1885# Usage:
1886# -a NAME -- add command named NAME
1887# -d NAME -- remove command named NAME
1888# -f FILE -- specify plugin configuration FILE to extract command definition from
1889#
1890# Sample:
1891# %triggerin -- nagios-nrpe
1892# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1893#
1894# %triggerun -- nagios-nrpe
1895# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1896#
1897# Requirements:
f236a3c2 1898# Requires: grep
1899# Requires: sed >= 4.0
d7cee36f 1900# BuildRequires: rpmbuild(macros) >= 1.552
2f79ae5a 1901%nagios_nrpe(a:d:c:f:) {\
d7cee36f 1902 m=$(md5sum < /etc/nagios/nrpe.cfg); \
2f79ae5a 1903 %{-a:# on -a and config exists \
d7cee36f
ER
1904 if [ -f /etc/nagios/nrpe.cfg ]; then \
1905 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1906 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
2f79ae5a
ER
1907 fi; \
1908 fi;} \
1909 %{-d:# on package remove, -d and config exists \
d7cee36f
ER
1910 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1911 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
2f79ae5a 1912 fi;} \
d7cee36f
ER
1913 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1914 %service -q nrpe restart; \
1915 fi; \
2f79ae5a
ER
1916}%{nil}
1917
070aa9f4
ER
1918# Import or update Cacti template.
1919#
1920# Author: Elan Ruusamäe <glen@pld-linux.org>
1921#
1922# Usage:
1923# %cacti_import_template XMLFILE
1924# XMLFILE -- XML template to import
1925#
1926# Sample:
1927# %post
1928# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1929#
1930# Requires: cacti >= 0.8.7e-8
1931# BuildRequires: rpmbuild(macros) >= 1.554
1932
1933%cacti_import_template() {\
1934/usr/share/cacti/cli/import_template.php --filename=%1 || :; \
1935}%{nil}
1936
cdb82983
JK
1937# pre/post script for -upstart subpackages
1938#
1939# Author: Jacek Konieczny <jajcus@jajcus.net>
1940#
1941# Usage:
1942# %upstart_post service_name
1943# %upstart_postun service_name
1944#
1945# Sample:
1946# %post upstart
1947# %upstart_post %{name}
1948#
1949# %postun upstart
1950# %upstart_postun %{name}
1951#
1952# Requirements:
1953# BuildRequires: rpmbuild(macros) >= 1.560
1954# Requires: rc-scripts >= 0.4.3
1955
1956# migrate from init script to upstart job
c4c1a53f 1957%upstart_post() \
cdb82983
JK
1958 if [ -f /var/lock/subsys/"%1" ] ; then \
1959 /sbin/service --no-upstart "%1" stop \
1960 /sbin/service "%1" start \
1961 fi
1962
1963# restart the job after upgrade or migrate to init script on removal
1964# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
1965# at this point
c4c1a53f 1966%upstart_postun() \
cdb82983
JK
1967 if [ -x /sbin/initctl ] && /sbin/initctl status "%1" 2>/dev/null | grep -q 'running' ; then \
1968 /sbin/initctl stop "%1" >/dev/null 2>&1 \
1969 [ -f "/etc/rc.d/init.d/%1" -o -f "/etc/init/%1.conf" ] && { echo -n "Re-" ; /sbin/service "%1" start ; } ; \
1970 fi
1971
f51bfb2f 1972# vim:ts=4 sw=4 noet ft=spec
This page took 0.486318 seconds and 4 git commands to generate.